<?
# Module: cache
# basic-cache.inc - Basic cache functions
# Derechos Reservados (c) 2001 Sandino Araico Snchez
# Derechos Reservados (c) 2001 Presidencia de la Repblica
# Copyright (c) 2001 Sandino Araico Snchez All rights reserved

/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */

# Changelog: 
# 2001-02-18 Sandino Araico Snchez - Cache de documentos originales
# 2001-03-12 Sandino Araico Snchez - Optimizaciones en el chequeo de directorios
# 2001-03-13 Sandino Araico Snchez - Cache de documentos procesados
# 2001-03-16 Sandino Araico Snchez - Librera autnoma hopp
# 2001-03-19 Sandino Araico Snchez - Workaround: $__APP_INCLUDE_PATH_, compatibilidad con PHP3
# 2001-09-18 Sandino Araico Snchez - Cambio de nombre, inclusin en Hopp

if(!defined("__HOPP_BASIC_CACHE_"))
{
	define("__HOPP_BASIC_CACHE_",1);
//--------------------------------------------------------------------
include __HOPP_INCLUDE_PATH."s.inc";
//--------------------------------------------------------------------

function hopp_put_doc_array_into_cache($host, $url, $array)
{
	hopp_put_remote_doc_array_into_cache($host, $url, $array);
}

function hopp_put_remote_doc_array_into_cache($host, $url, $array)
{
	$file_name=hopp_get_file_name_from_url($host, $url);
	hopp_put_generic_array_into_cache($file_name.".doc", $array);
	hopp_put_generic_array_into_cache($file_name.".md5", $array["DOC_MD5"]);
}

function hopp_put_local_doc_array_into_cache($string, $doc)
{
	$file_name=hopp_get_file_name_from_string($string).".doc";
	hopp_put_generic_array_into_cache($file_name, $doc, 1, 0);
}

function hopp_put_parts_array_into_cache($host, $array)
{
	$file_name=hopp_get_file_name_from_md5($host, $array["DOC_MD5"]);
	hopp_put_generic_array_into_cache($file_name.".parts", $array);
}

function hopp_put_generic_array_into_cache($file_name, $object, $first=1, $serialize=1)
{
	if($serialize)
		$object=serialize($object);
	$file_ptr=@fopen($file_name,"w");
	if($file_ptr)
	{
		fwrite ($file_ptr, $object);
		fclose($file_ptr);
	}
	else
	{	
		if($first)
		{
			hopp_check_cache_dir($file_name);
			hopp_put_generic_array_into_cache($file_name, $object, 0, $serialize);
		}	
	}
}

function hopp_put_doc_md5_into_cache($file_name, $md5_doc)
{
	$md5_file_name="$file_name.md5";
	$md5_fizle_ptr=fopen($md5_file_name,"w");
	if($md5_file_ptr)
	{
		fwrite ($md5_file_ptr, $md5_doc);
		fclose($md5_file_ptr);
	}
}

function hopp_include_local_doc_array_from_cache($param_string, $ttl, $check_old=1)
{
	$file_name=hopp_get_file_name_from_string($param_string).".doc";
	if($check_old)
		if(hopp_is_old_cache_file($ttl, $file_name))
			return;
	if(file_exists($file_name))	
		if(filesize ($file_name))
		{
			include $file_name;
			return 1;
		}
}

function hopp_get_doc_array_from_cache($host, $url, $check_old=1)
{
	return hopp_get_remote_doc_array_from_cache($host, $url, $check_old);
}

function hopp_get_remote_doc_array_from_cache($host, $url, $check_old=1)
{
	global $__TTL__;
	$file_name=hopp_get_file_name_from_url($host, $url).".doc";
	return hopp_get_generic_array_from_cache($__TTL__[$host], $file_name, $check_old);
}

function hopp_get_old_remote_doc_array_from_cache($host, $url)
{
	return hopp_get_remote_doc_array_from_cache($host, $url, 0);
}

function hopp_get_local_doc_array_from_cache($param_string, $ttl, $check_old=1)
{
	$file_name=hopp_get_file_name_from_string($param_string).".doc";
	return hopp_get_generic_array_from_cache($ttl, $file_name, $check_old,0);
}

function hopp_get_old_local_doc_array_from_cache($param_string, $ttl)
{
	return hopp_get_local_doc_array_from_cache($param_string, $ttl, 0);
}

function hopp_get_parts_array_from_cache($host, $url)
{
	global $__TTL__;
	$file_name=hopp_get_file_name_from_url($host, $url).".md5";
	$md5doc=hopp_get_generic_array_from_cache($__TTL__[$host], $file_name, 1);
	s_log("md5doc: $md5doc",0,0,3);
	if(strlen($md5doc)==32)
	{
		$file_name=hopp_get_file_name_from_md5($host, $md5doc).".parts";
		return hopp_get_generic_array_from_cache($__TTL__[$host], $file_name, 0);
	}	
}

function hopp_get_generic_array_from_cache($ttl, $file_name, $check_old, $unserialize=1)
{
	s_log("Looking for $file_name",0,0,3);
	if(file_exists($file_name))
	{
		s_log("Looking for $file_name: exists",0,0,3);
		if($check_old)
			if(hopp_is_old_cache_file($ttl, $file_name))
				return;
				
	}
	return hopp_get_array_from_cache_file($file_name, $unserialize);
}

function hopp_get_array_from_cache_file($file_name, $unserialize=1)
{
	if(file_exists($file_name))
	{
		$file_ptr=fopen($file_name,"r");
		if($file_ptr)
		{
			$file=fread($file_ptr,filesize($file_name));
			#s_log("===========> file <===========\n $file\n=================================",0,0,3);
			fclose($file_ptr);
			if($unserialize)
				$file=unserialize($file);
			return $file;
		}
	}
}

function hopp_is_old_cache_file($ttl, $file_name)
{
	$oldtime=time()-filemtime ($file_name);
	s_log("file_name: $file_name\toldtime: $oldtime",0,0,3);
	if($oldtime>$ttl)
		return 1;
}

function hopp_get_file_name_from_url($host, $url)
{
	return hopp_get_file_name_from_host_and_string($host, $url);
}

function hopp_get_file_name_from_string($string)
{
	return hopp_get_file_name_from_host_and_string('HOPP', $string);
}

function hopp_get_file_name_from_host_and_string($host, $string)
{
	$hash_pre=md5($string);
	//s_log("hash_pre: $hash_pre",0,0,3);
	return hopp_get_file_name_from_md5($host, $hash_pre);
}

function hopp_get_file_name_from_md5($host, $hash_pre)
{
	$time_0=s_time();
	$subdir=substr($hash_pre,0,__HOPP_BASIC_CACHE_DEPTH);
	$hash=substr($hash_pre,__HOPP_BASIC_CACHE_DEPTH,32);
	s_log("MD5\nhash_pre:\t$hash_pre\nsubdir\t\t$subdir\nhash:\t\t$hash",0,0,3);
	
	$filename=__HOPP_BASIC_CACHE_DIR_NAME."/$host/$subdir/$hash";

	$time_1=s_time();
	s_log("Cache Filename Time:\t".($time_1-$time_0),0,0,3);
	return $filename;
}

function hopp_check_cache_dir($filename, $hops=0)
{
	if($hops>__HOPP_BASIC_CACHE_DIR_MAX_HOPS)
		return;
	if(ereg("\/", $filename))
		$dirname=dirname($filename);
	else
		$dirname=$filename;
	s_log("filename: $filename\tdirname: $dirname\thops: $hops",0,0,3);
	
	if(!file_exists($dirname))
	{
		if(ereg("\/", $dirname))
			hopp_check_cache_dir($dirname, $hops+1);
		mkdir($dirname, __HOPP_BASIC_CACHE_DIR_MODE);
	}
}

//--------------------------------------------------------------------
} //__HOPP_BASIC_CACHE_
?>
